#################################
# unit tests

class DependencyVersionTests(TestCase):
        
    def testNoCommonDependencies(self):
        tasks = [
                 DependencyTask('t1'),
                 DependencyTask('t1', (Dependency('t2', '0.2.0', '>='),))
                 ]
        
        t = isVersionCompatible(tasks[0], tasks[1])
        self.assertEqual(tasks[1], t)
        
    def testCompatibleDependencies(self):
        tasks = [
                 DependencyTask('t1', (Dependency('t2', '0.1.0', '>='),)),
                 DependencyTask('t1', (Dependency('t2', '0.2.0', '>='),))
                 ]
        
        t = isVersionCompatible(tasks[0], tasks[1])
        self.assertEqual(tasks[1], t)
        

class DependencyGraphTest(TestCase):

    def testGraph(self):

        tasks = [
            DependencyTask('t1'),
            DependencyTask('t2', (Dependency('t1', '0.1.0', '>='), ) )

            ]
        
        pool = DependencyGraphPool('pool')


        for t in tasks:
            pool.addTask(t)
        
class InstallEngineTests(TestCase):
    pass

def test_suite():
    return TestSuite((
        makeSuite(InstallEngineTests),
        makeSuite(DependencyGraphTest),
        makeSuite(DependencyVersionTests)
        ))

if __name__=='__main__':
    main(defaultTest='test_suite')
