"""
  Purpose: Core Zope Tasks
  Author: kapil <kapil@sanhawk.net>
  Created: 7/11/2002
  CVS: $Id: CoreTasks.py,v 1.10 2002/09/21 07:17:47 kapil Exp $
"""


def install_zope(config, root):

    # you really don't want to know.
    from AccessControl import User
    from AccessControl.SecurityManagement import newSecurityManager
    from AccessControl.SpecialUsers import system

    line = "root:{SHA}vHNA+LrsAJfQ2w4ehfYf5r8f5/Q="
    data = line.strip().split(':')
    remote_user_mode = not data[1]
    try:    ds = data[2].split(' ')
    except: ds = []
    
    user_info = ( data[0], data[1], ds, remote_user_mode)
    name, password, domains, remote_user_mode = user_info
    
    udb = root.acl_users
    try: udb._doDelUsers('root')
    except: pass
    udb._doAddUser(name, password, ('Manager',), domains)
    user = udb.getUser(name).__of__(udb)
    
    newSecurityManager(None, user) 
    
    return root

def null_task(config, root):
    pass

def install_plone(config, root):

    root.manage_addProduct['CMFPlone'].manage_addSite(
        id=config.cmf_site_id,
        title=config.cmf_site_title,
        create_userfolder= int(config.create_userfolder),
        description=config.description,
        email_from_address=config.cmf_admin_email,
        email_from_name=config.cmf_admin_name,
        validate_email=0
        )

    return getattr(root, config.cmf_site_id)

def install_oracle_connection(config, root):

    factory = root.manage_addProduct['DCOracle2']

    factory.manage_addZOracleConnection(
        id = config.oracle_connection_id,
        title = config.oracle_connection_id,
        connection_string = config.oracledsn,
        check = 1
        )

    return getattr(root, config.oracle_connection_id)
    
def install_xuf(config, cmf):

    from UserDict import UserDict
    class XUFRequest(UserDict):
        def __nonzero__(self):
            return 0

    try: cmf.manage_delObjects(['acl_users'])
    except: pass
    
    
    d = {}
    d['oracle_connection_id']=config.oracle_connection_id
    r = XUFRequest(d)
    
    d = {}
    d['authId'] = config.authsource
    d['propId'] = config.propsource
    d['memberId'] = config.membersource
    d['cookie_mode'] = int(config.cookiemode)
    d['REQUEST']=r

    
    cmf.manage_addProduct['exUserFolder'].manage_addexUserFolder(**d)

    return getattr(cmf, 'acl_users')

