import os
import inspect
from os import path

import Utils
from Context import Context
from Log import setLogLevel

from lib.optik import OptionParser

def CommandLineContextFactory():

    parser = OptionParser()
    
    parser.add_option("-c", "--config",
                      help="specify configuration directory",
                      dest="SourceDirectory")
    
    parser.add_option("-p", "--pattern",
                      help="specify configuration directory",
                      dest="TaskFilePattern",
                      default="*.ini")
    
    parser.add_option("-l", "--log-level",
                      help="specify default logging level",
                      action="callback",
                      callback=setLogLevel,
                      type="string",
                      dest="LogLevel")
    
    parser.add_option("-z", "--zope",
                      help="specify whether running on zope",
                      action="store_true",
                      dest="Zope"
                      )
    
    parser.parse_args()

    return Context("command-line", parser.values.__dict__)

def EnvironmentContextFactory():

    return Context("environment", os.environ.copy())

def LocationContextFactory():

    return Context("location", {'EngineHome':path.dirname(Utils.__file__)})

if __name__ == '__main__':
    print CommandLineContextFactory()

