
import types

from lib.Interface import Base as Interface
from lib.Interface import Attribute


def die():
    # clean up and die
    import sys
    sys.exit(1)

def sort_by_attr(seq, attr):
    """
    credits: yakov markovitch,  nick perkins
    from: python cookbook
    license: modified bsd
    """
    from operator import getitem
    intermed = map(None, map(getattr, seq, (attr,)*len(seq)),
                   xrange(len(seq)), seq)
    intermed.sort()
    return map(getitem, intermed, (-1,)*len(intermed))

def unique(seq):
    """
    unique function for sequences. in the case of
    duplicates we keep the first element.
    """
    s = {}
    hk = s.has_key
    result = []
    a = result.append
    
    for i in seq:
        if hk(i): continue
        s[i] = None
        a(i)
        
    return result                   

def zope_setup_load_env(context):
    """
    hacks for zope instance home setups
    """

    import sys, os

    spath = context.get('SOFTWARE_HOME', None)
    ipath = context.get('INSTANCE_HOME', None)

    # hmm... i forget why, software home is at the end...
    if spath is not None: sys.path.append(spath)
    if ipath is not None: sys.path.insert(0, ipath)

    if ipath and ipath != '.': # ??
        package_file = os.path.join(ipath, 'Products', '__init__.py')
        if os.path.exists(package_file):
            return
        f  = open(package_file, 'w')
        f.write ('# temporary package init \n')
        f.close()

            
def zope_clean_load_env(context):
    """
    hacks for zope instance home setups
    """
    import sys, os
    possible_bad = []
    ipath = context.get('INSTANCE_HOME', None)    

    if ipath is not None:
        del sys.modules['Products']
        os.remove(os.path.join(ipath, 'Products', '__init__.py'))
        os.remove(os.path.join(ipath, 'Products', '__init__.pyc'))
        possible_bad = os.listdir(os.path.join(ipath, 'Products'))
        
    while sys.path.count(ipath) > 0:
        sys.path.remove(ipath)

    return possible_bad

def default_identifier(self, klass=None):
    klass = klass or self
    if type(klass) == types.InstanceType:
        klass = klass.__class__
    return klass.__name__

def default_importer(modulepath, thing):
    # ipc10 tshirt - import this 
    m = __import__(modulepath, globals(), locals(), [thing])
    return getattr(m, thing)

class SimpleClassRegistry:

    identifier = default_identifier
    
    def __init__(self, regid='Unknown'):
        self.id = regid
        self.data = {}

    def addClass(self, klass, identity=None):
        name = identity or self.identifier(klass)
        self.data[name]=klass

    def getClass(self, identifier):
        return self.data[identifier]

    def setIdentifier(self, func):
        self.identifier = func


