from unittest import TestCase, TestSuite, main, makeSuite
from CSInstaller.TaskLoader import TaskLoader
from cStringIO import StringIO

sample_config = """
[ZopeTask-InstallCMFRoot]
Module: CSInstaller.tests.TaskLoaderTests
Function: sample_task_function
Depends: InstallZope

[Task-InstallQueue]
Module: CSInstaller.tests.TaskLoaderTests
Function: sample_task_function
smtp_host: mail.wm.edu

[ZopeTask-InstallZope]
Module: CSInstaller.tests.TaskLoaderTests
Function: sample_task_function
instance_home: /data/zope

[Task-CVSCheckOut]
Module: CSInstaller.tests.TaskLoaderTests
Function: sample_task_function
cvsroot: :ext:sysadmin@fileserver:/data/repository/cvsroot
cvsmodule: cwip
depends: InstallQueue
"""

def sample_task_function(config=None, persistent_obj=None):
    pass

class TaskLoaderTests(TestCase):

    def testLoader(self):

        loader = TaskLoader()
        tasks = loader.load(StringIO(sample_config))

        self.assertEqual(len(tasks), 4, "Tasks not loaded properly")
        
def test_suite():
    return TestSuite((
        makeSuite(TaskLoaderTests),
        ))

if __name__=='__main__':
    main(defaultTest='test_suite')

